package com.iformall.controller;

import com.github.pagehelper.PageInfo;
import com.iformall.common.ErrorCode;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.domain.po.*;
import com.iformall.enums.EnumPayType;
import com.iformall.exception.MallinkException;
import com.iformall.service.WxRefundOrderService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@RequestMapping("/api/refund")
@Api(description = "退款相关接口")
public class WxRefundOrderController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxRefundOrderService wxRefundOrderService;

    @ApiOperation(value = "退券退款", notes = "{\"couponOrderId\":\"string\"}")
    @PostMapping("/create")
    public ResultData create(@RequestBody Map<String, String> paramMap) {
        //Assert.notNull(wxRefundOrder.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        logger.info(paramMap.toString());
        String couponOrderIdStr = paramMap.get("couponOrderId");
        if (StringUtils.isBlank(couponOrderIdStr)) {
            logger.error("couponOrderId不能为空: " + paramMap.toString());
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL);
        }
        Long couponOrderId = 0L;
        try {
            couponOrderId = Long.valueOf(couponOrderIdStr);
        } catch (NumberFormatException e) {
            logger.error("couponOrderId参数不正确: " + paramMap.toString());
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL);
        }

        WxMerchantBUser bUser = getUser();
        WxAppinfo appinfo = getAppInfo(bUser.getAppId());
        try {
            ResultData rd = wxRefundOrderService.createRefundOrder(appinfo, couponOrderId, EnumPayType.PAY_B_REFUND, bUser.getId());
            return rd;
        } catch (MallinkException e) {
            logger.error(e.getMessage());
            return new ResultData(e.getErrorCode(), e.getMessage());
        } catch (Exception e) {
            logger.error(e.getMessage());
            return new ResultData(ErrorCode.REFUND_ORDER_ERROR);
        }
    }

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxRefundOrder wxRefundOrder, Integer pageNum, Integer pageSize) {
        if (null == wxRefundOrder) wxRefundOrder = new WxRefundOrder();
        final PageInfo<WxRefundOrder> page = wxRefundOrderService.listAsPage(wxRefundOrder, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findById(Long id) {
        return new ResultData(Result.SUCCESS, "查询成功", wxRefundOrderService.getById(id));
    }


}
